#ifndef __KEYCODE_H__
#define __KEYCODE_H__

#define ID_KB_A                 0x04            //A a
#define ID_KB_B                 0x05            //B b
#define ID_KB_C                 0x06            //C c
#define ID_KB_D                 0x07            //D d
#define ID_KB_E                 0x08            //E e
#define ID_KB_F                 0x09            //F f
#define ID_KB_G                 0x0A            //G g
#define ID_KB_H                 0x0B            //H h
#define ID_KB_I                 0x0C            //I i
#define ID_KB_J                 0x0D            //J j
#define ID_KB_K                 0x0E            //K k
#define ID_KB_L                 0x0F            //L l
#define ID_KB_M                 0x10            //M m
#define ID_KB_N                 0x11            //N n
#define ID_KB_O                 0x12            //O o
#define ID_KB_P                 0x13            //P p
#define ID_KB_Q                 0x14            //Q q
#define ID_KB_R                 0x15            //R r
#define ID_KB_S                 0x16            //S s
#define ID_KB_T                 0x17            //T t
#define ID_KB_U                 0x18            //U u
#define ID_KB_V                 0x19            //V v
#define ID_KB_W                 0x1A            //W w
#define ID_KB_X                 0x1B            //X x
#define ID_KB_Y                 0x1C            //Y y
#define ID_KB_Z                 0x1D            //Z z
#define ID_KB_1                 0x1E            //1 !
#define ID_KB_2                 0x1F            //2 @
#define ID_KB_3                 0x20            //3 #
#define ID_KB_4                 0x21            //4 $
#define ID_KB_5                 0x22            //5 %
#define ID_KB_6                 0x23            //6 ^
#define ID_KB_7                 0x24            //7 &
#define ID_KB_8                 0x25            //8 *
#define ID_KB_9                 0x26            //9 (
#define ID_KB_0                 0x27            //0 )
#define ID_KB_Enter             0x28            //
#define ID_KB_Escape            0x29            //
#define ID_KB_Backspace         0x2A            //
#define ID_KB_Tab               0x2B            //
#define ID_KB_Space             0x2C            //
#define ID_KB_Minus             0x2D            //- _
#define ID_KB_Equ               0x2E            //= +
#define ID_KB_LBracket          0x2F            //[ {
#define ID_KB_RBracket          0x30            //] }
#define ID_KB_Backslash         0x31            //\ |
#define ID_KB_Code42            0x32            //
#define ID_KB_Semicolon         0x33            //; :
#define ID_KB_Apostrophe        0x34            //' "
#define ID_KB_Tilde             0x35            //` ~
#define ID_KB_Comma             0x36            //, <
#define ID_KB_Dot               0x37            //. >
#define ID_KB_Div               0x38            /// ?
#define ID_KB_CapsLock          0x39            //
#define ID_KB_F1                0x3A            //
#define ID_KB_F2                0x3B            //
#define ID_KB_F3                0x3C            //
#define ID_KB_F4                0x3D            //
#define ID_KB_F5                0x3E            //
#define ID_KB_F6                0x3F            //
#define ID_KB_F7                0x40            //
#define ID_KB_F8                0x41            //
#define ID_KB_F9                0x42            //
#define ID_KB_F10               0x43            //
#define ID_KB_F11               0x44            //
#define ID_KB_F12               0x45            //
#define ID_KB_PrintScreen       0x46            //
#define ID_KB_ScrollLock        0x47            //
#define ID_KB_Pause             0x48            //
#define ID_KB_Insert            0x49            //
#define ID_KB_Home              0x4A            //
#define ID_KB_PageUp            0x4B            //
#define ID_KB_Delete            0x4C            //
#define ID_KB_End               0x4D            //
#define ID_KB_PageDown          0x4E            //
#define ID_KB_Right             0x4F            //
#define ID_KB_Left              0x50            //
#define ID_KB_Down              0x51            //
#define ID_KB_Up                0x52            //
#define ID_KP_NumLock           0x53            //
#define ID_KP_Div               0x54            ///
#define ID_KP_Multiply          0x55            //*
#define ID_KP_Minus             0x56            //-
#define ID_KP_Plus              0x57            //+
#define ID_KP_Enter             0x58            //
#define ID_KP_1                 0x59            //1
#define ID_KP_2                 0x5A            //2
#define ID_KP_3                 0x5B            //3
#define ID_KP_4                 0x5C            //4
#define ID_KP_5                 0x5D            //5
#define ID_KP_6                 0x5E            //6
#define ID_KP_7                 0x5F            //7
#define ID_KP_8                 0x60            //8
#define ID_KP_9                 0x61            //9
#define ID_KP_0                 0x62            //0
#define ID_KP_Dot               0x63            //.
#define ID_KB_Code45            0x64            //
#define ID_KB_App               0x65            //

#define ID_MK_NextTrack         0x00B5
#define ID_MK_PrevTrack         0x00B6
#define ID_MK_MediaStop         0x00B7
#define ID_MK_MediaPlay         0x00CD
#define ID_MK_Mute              0x00E2
#define ID_MK_VolumeInc         0x00E9
#define ID_MK_VolumeDec         0x00EA
#define ID_MK_MediaSelect       0x0183
#define ID_MK_Word              0x0184
#define ID_MK_Excel             0x0186
#define ID_MK_Mail              0x018A
#define ID_MK_Calendar          0x018E
#define ID_MK_Calculator        0x0192
#define ID_MK_MyComputer        0x0194
#define ID_MK_Messenger         0x0199
#define ID_MK_Logoff            0x019C
#define ID_MK_NextTask          0x01A3
#define ID_MK_PrevTask          0x01A4
#define ID_MK_MyDocument        0x01A7
#define ID_MK_MyPicture         0x01B6
#define ID_MK_MyMusic           0x01B7
#define ID_MK_Undo              0x021A
#define ID_MK_Copy              0x021B
#define ID_MK_Cut               0x021C
#define ID_MK_Paste             0x021D
#define ID_MK_WWWSearch         0x0221
#define ID_MK_WebHome           0x0223
#define ID_MK_WWWBack           0x0224
#define ID_MK_WWWForward        0x0225
#define ID_MK_WWWStop           0x0226
#define ID_MK_WWWRefresh        0x0227
#define ID_MK_WWWFavorite       0x022A
#define ID_MK_ZoomIn            0x022D
#define ID_MK_ZoomOut           0x022E

#define ID_KB_Power             0x01
#define ID_KB_Sleep             0x02
#define ID_KB_Wakeup            0x04

#endif
