/*---------------------------------------------------------------------*/
/* --- STC MCU Limited ------------------------------------------------*/
/* --- STC 1T Series MCU Demo Programme -------------------------------*/
/* --- Mobile: (86)13922805190 ----------------------------------------*/
/* --- Fax: 86-0513-55012956,55012947,55012969 ------------------------*/
/* --- Tel: 86-0513-55012928,55012929,55012966 ------------------------*/
/* --- Web: www.STCAI.com ---------------------------------------------*/
/* --- BBS: www.STCAIMCU.com  -----------------------------------------*/
/* --- QQ:  800003751 -------------------------------------------------*/
/* Ҫڳʹô˴,ڳעʹSTCϼ        */
/*---------------------------------------------------------------------*/

#include "stc.h"
#include "uart.h"
#include "usb.h"
#include "util.h"
#include "usb_req_class.h"

BOOL UartBusy;

void uart_init()
{
    P_SW2 &= ~0x01;     //UART2 switch to: 0: P1.0 P1.1

    P1M0 &= ~0x03;      //P1.0,P1.1Ϊ׼˫ģʽ
    P1M1 &= ~0x03;

    S2CON = 0x50;
    T2L = BR(115200);
    T2H = BR(115200) >> 8;
    AUXR |= 0x14;	      //ʱ2ʱ1Tģʽ,ʼʱ
    IE2  |= 1;            //ж

    LineCoding.dwDTERate = REV4(115200);
    LineCoding.bCharFormat = 0;
    LineCoding.bParityType = 0;
    LineCoding.bDataBits = 8;
}

void uart2_isr() interrupt UART2_VECTOR
{
    if((S2CON & 2) != 0)
    {
        S2CON &= ~2;    //Clear Tx flag
        UartBusy = 0;
    }

    if((S2CON & 1) != 0)
    {
        S2CON &= ~1;    //Clear Rx flag
        TxBuffer[TxWptr++] = S2BUF;
    }
}

void uart_set_parity(BYTE parity)
{
    switch (parity)
    {
    case NONE_PARITY:
        S2CON = 0x50;
        break;
    case ODD_PARITY:
    case EVEN_PARITY:
    case MARK_PARITY:
        S2CON = 0xda;
        break;
    case SPACE_PARITY:
        S2CON = 0xd2;
        break;
    }
}

void uart_set_baud(DWORD baud)
{
    WORD temp;

    temp = (WORD)BR(baud);
    T2L = temp;
    T2H = temp >> 8;
}

void uart_polling()
{
//    BYTE dat;
//    BYTE cnt;

//    if (DeviceState != DEVSTATE_CONFIGURED)
//        return;

//    if (!UsbInBusy && (TxRptr != TxWptr))
//    {
//        IE2 &= ~0x80;   //EUSB = 0;
//        UsbInBusy = 1;
//        usb_write_reg(INDEX, 3);
//        cnt = 0;
//        while (TxRptr != TxWptr)
//        {
//            usb_write_reg(FIFO3, TxBuffer[TxRptr++]);
//            cnt++;
//            if (cnt == EP1IN_SIZE) break;
//        }
//        usb_write_reg(INCSR1, INIPRDY);
//        IE2 |= 0x80;    //EUSB = 1;	
//    }

//    if (!UartBusy && (RxRptr != RxWptr))
//    {
//        dat = RxBuffer[RxRptr++];
//        UartBusy = 1;
//        switch (LineCoding.bParityType)
//        {
//        case NONE_PARITY:
//			
//        case SPACE_PARITY:
//		    S2CON &= ~(1 << S2TB8 );
//            break;
//        case ODD_PARITY:
//            ACC = dat;
//			if(!P)
//			{			
//				S2CON |= 1 << S2TB8 ;
//			}
//			else
//			{
//				S2CON &= ~(1 << S2TB8 );
//			}
//            break;
//        case EVEN_PARITY:
//            ACC = dat;
//            if(P)
//			{			
//				S2CON |= 1 << S2TB8 ;
//			}
//			else
//			{
//				S2CON &= ~(1 << S2TB8 );
//			}
//            break;
//        case MARK_PARITY:
//			S2CON |= 1 << S2TB8 ;
//            break;	
//        }
//        S2BUF = dat;

//        while (UartBusy);
//    }

//    if (UsbOutBusy)
//    {
//        IE2 &= ~0x80;   //EUSB = 0;
//        if (RxWptr - RxRptr < 256 - EP1OUT_SIZE)
//        {
//            UsbOutBusy = 0;
//            usb_write_reg(INDEX, 3);
//            usb_write_reg(OUTCSR1, 0);
//        }
//        IE2 |= 0x80;    //EUSB = 1;	
//    }
}



//void uart_polling()
//{
//    BYTE cnt;

//    if (DeviceState != DEVSTATE_CONFIGURED)
//        return;

//    if(!UsbInBusy && (RxRptr != RxWptr))		//յ
//    {
//			
//        IE2 &= ~0x80;   //EUSB = 0;
//        UsbInBusy = 1;
//        usb_write_reg(INDEX, 3);
//        cnt = 0;
//        while (RxRptr != RxWptr)
//        {
//            usb_write_reg(FIFO3, RxBuffer[RxRptr++]);
//            cnt++;
//            if (cnt == EP1IN_SIZE) break;
//        }
//        usb_write_reg(INCSR1, INIPRDY);
//        IE2 |= 0x80;    //EUSB = 1;		
//	}
//	
//    if (UsbOutBusy)
//    {
//        IE2 &= ~0x80;   //EUSB = 0;
//        if (RxWptr - RxRptr < 256 - EP1OUT_SIZE)
//        {
//            UsbOutBusy = 0;
//            usb_write_reg(INDEX, 3);
//            usb_write_reg(OUTCSR1, 0);
//        }
//        IE2 |= 0x80;    //EUSB = 1;
//    }
//}
